/*
 *  ngtk/c/ngtk_utils.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *
 */

/*----------------------------------------------------------------------------

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the 
    Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
    Boston, MA  02111-1307  USA.

----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>

void ngtk_dumb_func(void)
{
}

void ngtk_clrwin(WINDOW *win, chtype pat, int refresh)
{
    int i;
	int len = ((win->_maxx)+1) * ((win->_maxy)+1);
    char buf[len+1];

    werase(win);

	if (win->_maxx == 0)
		for (i=0 ; i <= win->_maxy ; i++)
			mvwaddch(win, i, 0, pat);
	else {
	    memset(&buf[0], pat, len);
		waddnstr(win, buf, len);
	}
    wmove(win, 0, 0);

    if (!refresh)
        wnoutrefresh(win);
    else
        wrefresh(win);
}

void ngtk_clreol(WINDOW *win, char pat, int refresh)
{
    int y, x;
    char buf[COLS+1];

    getyx(win, y, x);

    wclrtoeol(win);
    memset(&buf[0], pat, win->_maxx+1);
    waddnstr(win, buf, win->_maxx+1);
    wmove(win, y, 0);

    if (!refresh)
        wnoutrefresh(win);
    else
        wrefresh(win);
}

void ngtk_init_pairs(void)
{
    int i,j,k = 0;

    for (i=0;i<=7;i++)
        for (j=0;j<=7;j++) {
            init_pair(k, j, i);
            k++;
        }
}

void setfg(ngtk_win_t *win, int color, int attr)
{
	wattrset(win->win, COLOR_PAIR(((PAIR_NUMBER(win->win->_attrs)/8)*8)+ color) | attr);
}

void ngtk_register_key(int keysym, void (*func)(), char *keydsc, char *funcdsc,
					   int disp_foot)
{
	if (disp_foot) {
	    strncpy(t_bar1[t_bar], keydsc, 1024);
	    strncpy(t_bar2[t_bar], funcdsc, 1024);
	    t_bar++;
	}

    functable[key_table].keysym = keysym;
    functable[key_table].func = func;
	key_table++;
}

int ngtk_wscrl(WINDOW *win, int n)
{
	return(wscrl(win, n));
}

void ngtk_dccprintf(ngtk_win_t *win, int c1, int a1, int c2, int a2, char *str)
{
    wattrset(win->win, COLOR_PAIR(c1) | a1);
    wprintw(win->win, "%c", str[0]);

    wattrset(win->win, COLOR_PAIR(c2) | a2);
    wprintw(win->win, "%s", &str[1]);
    wrefresh(win->win);
}

