/*
 *  ngtk/test/progress_bar.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *
 */

/*----------------------------------------------------------------------------
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>
#include "ngtk_test.h"

void cleanup_pbar(void)
{
    ngtk_topbar(56, A_NORMAL, version_info, 0);
}

void pbar(void)
{
    int i, j;
    ngtk_pbar_t *p_bar = ngtk_mk_pbar(22);
	ngtk_win_t *box;
    int top = (LINES / 2) - 2;
    int left = (COLS / 2) - 12;


    /* increase the speed factor if the bar scrolls too fast */
    int speed_factor = 10;

    ngtk_topbar(56, A_NORMAL, " Progress Bar Test ", 0);

    box = ngtk_mkbox(5, 25, top, left, WHITE_F(WHITE_B), A_BOLD, "Progress Bar Test",\
					 0, 1, 0);
    mvwprintw(box->win, 1, 7, "Please Wait");

    ngtk_show_pbar(p_bar, top+2, left+1, WHITE_F(WHITE_B), A_BOLD);

    for (i=0;i<=100;i++) {
        for (j=0;j<=10000 * speed_factor;j++);
        ngtk_update_pbar(p_bar, i);
    }

    ngtk_pull_win(box);
    mvwprintw(box->win, 1, 7, "Press a key");
	wrefresh(box->win);
	ngtk_pull_win(p_bar->container);
    wgetch(box->win);
    ngtk_destroy_pbar(p_bar);
    ngtk_pop_win(box);

    cleanup_pbar();
}

void init_pbar(void)
{
    ngtk_register_key(NGTK_KEY_F(5), pbar, "F5", "Progress", 1);
}
